package misc;

import java.util.Random;

/**
 * The PrintNetwork class is used to quickly output all the arcs in a fully
 * connected graph of a specified size.
 */
public class PrintNetwork{
	
	/**
	 * The driver method for the PrintNetwork class.
	 * @param args A single integer argument: The number of vertices
	 */
	public static void main(String[] args){
		
		int size = Integer.parseInt(args[0]);
		double b, d, u;
		Random rand = new Random();
		
		for(int i=0; i < size; i++){
			for(int j=0; j < size; j++){
				if(i != j){
					u = rand.nextDouble();
					b = ((1.0-u)/2.0);
					d = (1.0 - u - b);
					System.out.print("["+i+"->"+j+",("+round(b,3)+","+
							round(d,3)+","+round(u,3)+","+"0.5)]+");
				} // Don't output cyclic arcs where (source == target) 
			} // Output all arcs in a fully connected graph with 'size' vertices
		} // Output all arcs in a fully connected graph with 'size' vertices
		System.out.println(); // Clear line on terminal
	}
	
	/**
	 * Round a double value to a specified accuracy.
	 * @param value Double to be rounded
	 * @param decPlaces Number of positions following the decimal to permit
	 * @return Double 'value' truncated after 'decPlaces' trailing digits
	 */
	private static double round(double value, int decPlaces){
	    double powerOfTen = 1;
	    while (decPlaces-- > 0)
	    	powerOfTen *= 10.0;
	    return Math.round(value * powerOfTen) / powerOfTen;
	}

}
